﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace ChatHelper
{
    public partial class frmmain : Form
    {
        private class LItem
        {
            private string m_key = string.Empty;
            private string m_item = string.Empty;

            public string TheKey
            {
                get
                {
                    return m_key;
                }
                set
                {
                    m_key = value;
                }
            }

            public override string ToString()
            {
                return m_item;
            }

            public LItem(string item, string key)
            {
                m_item = item;
                m_key = key;
            }
        }

        FileInfo dFile = null;
        List<string> TheData = new List<string>();

        public frmmain()
        {
            InitializeComponent();
        }

        private void GetDescriptions(char index)
        {
            int x = 0;
            char c = '\0';
            int spos = -1;
            string sKey = string.Empty;
            string sLine = string.Empty;

            //Clear listbox.
            LstDesc.Items.Clear();

            while (x < TheData.Count)
            {
                //Get data line.
                sLine = TheData[x];
                //Get position of =
                spos = sLine.IndexOf('=');

                if (spos != -1)
                {
                    //Get chat long description.
                    sLine = TheData[x].Substring(spos + 1).Trim();
                    //Get chat short text.
                    sKey = TheData[x].Substring(0, spos).Trim();
                    //Get first char convert to uppercase.
                    c = char.ToUpper(sLine[0]);
                    //Check char match.
                    if (c.Equals(index))
                    {
                        //Add to listbox.
                        LstDesc.Items.Add(new LItem(sLine, sKey));
                    }
                }
                //INC Counter.
                x++;
            }
        }

        private void LoadDataCats(string filename)
        {
            string sLine = string.Empty;

            try
            {
                using (StreamReader sr = new StreamReader(filename))
                {
                    while (!sr.EndOfStream)
                    {
                        sLine = sr.ReadLine().Trim();
                        //Get position of =
                        if (sLine.Length > 1)
                        {
                            //Add the data.
                            TheData.Add(sLine);
                        }
                    }
                    //Close filename.
                    sr.Close();
                }
            }
            catch { return; }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Data filename.
            dFile = new FileInfo(Path.Combine(Environment.CurrentDirectory, "data.txt"));
            int x = 0;

            //Add alphabet A-Z
            while (x < 26)
            {
                //Add chars A-Z
                cboCats.Items.Add((char)(65 + x));
                //INC Counter.
                x++;
            }

            //Check if data file is found.
            if (dFile.Exists)
            {
                //Load data file.
                LoadDataCats(dFile.FullName);
                //Set first index.
                cboCats.SelectedIndex = 0;
                if (LstDesc.Items.Count > 0)
                    LstDesc.SelectedIndex = 0;
            }
        }

        private void cboCats_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Char long descriptions.
            GetDescriptions(cboCats.Text[0]);
        }

        private void LstDesc_SelectedIndexChanged(object sender, EventArgs e)
        {
            LItem i = (LItem)LstDesc.Items[LstDesc.SelectedIndex];
            //Add chat abbreviation to text box.
            txtKey.Text = i.TheKey;
        }

        private void LnkCpy1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                if (txtKey.Text.Length > 0)
                {
                    //Hilight textbox.
                    txtKey.SelectAll();
                    txtKey.Focus();
                    //Copy text to clipboard.
                    Clipboard.SetText(txtKey.Text);
                }
            }
        }

        private void LnkCpy2_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                if (LstDesc.Text.Length > 0)
                {
                    //Copy text to clipboard.
                    Clipboard.SetText(LstDesc.Text);
                }
            }
        }

        private void frmmain_FormClosing(object sender, FormClosingEventArgs e)
        {
            //Clear data.
            TheData.Clear();
        }

        private void cmdExit_Click(object sender, EventArgs e)
        {
            //Close program.
            Close();
        }
    }
}
